#  Copyright (c) PARRRATE T&V 2021. All rights reserved.
import sys

from bu4.common_interface import with_common_interface
from bu4.evaluation.constructs.proxy import antiproxy, eproxy
from bu4.evaluation.sync import sync
from bu4.synced import synced
from bu4.parsing.toolchain.readfile import readfile
from timesample import TimeSample

sys.setrecursionlimit(13)

with TimeSample('all'):
    with TimeSample('sys0'):
        with TimeSample('compilation'):
            sys0 = synced(readfile('src/sys0'))
        with TimeSample('first, AP'):
            TimeSample.print(
                antiproxy(sys0)(0)(1)(
                    lambda a: lambda b: a + b
                )(
                    lambda n: lambda x: lambda y: x if n == 0 else y
                )(
                    lambda n: lambda x: lambda y: x if n & 1 else y
                )(
                    lambda n: n >> 1
                )
            )
        with TimeSample('second, AP'):
            TimeSample.print(
                antiproxy(sys0)(0)(1)(
                    lambda a: lambda b: a + b
                )(
                    lambda n: lambda x: lambda y: x if n == 0 else y
                )(
                    lambda n: lambda x: lambda y: x if n & 1 else y
                )(
                    lambda n: n >> 1
                )
            )
        with TimeSample('third, EP'):
            sys0 = with_common_interface(sys0)
            TimeSample.print(sys0)
    with TimeSample('sys2'):
        with TimeSample('compilation'):
            sys2c = synced(readfile('src/sys2'))
        with TimeSample('runtime'):
            sys2 = sys2c
            sys2 = with_common_interface(sys2)
            TimeSample.print(sys2)
        with TimeSample('runtime'):
            sys2 = sys2c
            sys2 = with_common_interface(sys2)
            TimeSample.print(sys2)
    with TimeSample('sys3'):
        sys3 = with_common_interface(synced(readfile('src/sys3')))
        sys3 = sync(sys3.call(eproxy(5)))
        TimeSample.print(sys3)
    with TimeSample('sys1'):
        sys1 = with_common_interface(synced(readfile('src/sys1')))
        sys1 = sync(sys1.call(eproxy(5)))
        sys1 = sync(sys1.call(eproxy(6)))
        TimeSample.print(sys1)
    with TimeSample('sys4'):
        TimeSample.print(with_common_interface(synced(readfile('src/sys4'))))
